import { computed as p, ref as b, onMounted as nt, watch as He, openBlock as a, createElementBlock as o, normalizeClass as P, normalizeStyle as q, unref as c, createBlock as O, createCommentVNode as v, createSlots as rt, withCtx as F, renderSlot as S, normalizeProps as J, guardReactiveProps as Q, createVNode as it, createElementVNode as d, Fragment as k, renderList as _, toDisplayString as m, withKeys as ct, createTextVNode as Me, nextTick as X } from "vue";
import { u as vt, o as dt, e as Z, g as ht, c as Re, t as yt, a as ft, p as ee, C as Ue, b as gt, J as bt, d as de, D as We, m as he, X as mt, s as G, E as xt, i as ye, f as te, j as Xe, k as le, n as Ge, K as je, q as pt, r as kt } from "./index-BVNcFEqn.js";
import { _ as _t } from "./Title-DyUTj8GI.js";
import { u as Ct, U as wt } from "./usePrinter-Bcfs_I6G.js";
import { D as zt } from "./DataTable-DX_jYNWG.js";
import { L as Lt } from "./Legend-DGUxLqhs.js";
import St from "./vue-ui-skeleton-Bgf16k10.js";
import { S as $t } from "./Slicer-CopZgIzh.js";
import At from "./vue-ui-accordion-GNblUy42.js";
import { u as Be } from "./useNestedProp-D79dWdel.js";
import { _ as Nt } from "./PackageVersion-B9_Ed72C.js";
import { P as It } from "./PenAndPaper-CzjoEhsO.js";
import { u as Ft } from "./useUserOptionState-BIvW1Kz7.js";
import { _ as Pt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Dt = ["id"], Ot = ["xmlns", "viewBox"], Et = ["x", "y", "width", "height"], Tt = ["id"], Vt = ["stop-color"], Ht = ["stop-color"], Mt = ["id"], Rt = ["stop-color"], Ut = ["stop-color"], Wt = ["stop-color"], Xt = { key: 1 }, Gt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], jt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Bt = { key: 0 }, Yt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Kt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], qt = ["x", "y", "font-size", "fill", "font-weight"], Jt = ["text-anchor", "font-size", "fill", "transform"], Qt = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], Zt = { key: 1 }, el = ["cx", "cy", "r", "fill"], tl = { key: 0 }, ll = { key: 0 }, al = ["d", "stroke"], ol = ["text-anchor", "x", "y", "fill"], ul = ["cx", "cy", "r", "fill"], sl = { key: 0 }, nl = ["cx", "cy", "fill"], rl = { key: 1 }, il = ["d", "fill", "stroke"], cl = { key: 2 }, vl = ["d", "fill", "stroke"], dl = ["x", "y", "font-size", "fill"], hl = ["x", "y", "width", "fill", "onClick"], yl = ["x", "y", "width", "height", "onMouseenter", "onClick"], fl = {
  key: 4,
  "data-cy-zoom": "",
  class: "vue-ui-donut-evolution-dialog"
}, gl = ["x", "y", "width", "height", "fill"], bl = ["x1", "y1", "x2", "y2", "stroke"], ml = ["x1", "y2", "x2", "y1", "stroke"], xl = ["onKeypress", "cx", "cy", "r"], pl = ["d", "stroke"], kl = ["cx", "cy", "r", "fill"], _l = ["d", "fill", "stroke"], Cl = { class: "vue-ui-donut-evolution-focus" }, wl = ["text-anchor", "x", "y", "fill"], zl = ["cx", "cy", "r", "fill"], Ll = ["cx", "cy", "r", "fill"], Sl = ["x", "y", "fill"], $l = ["x", "y", "font-size", "fill"], Al = {
  key: 5,
  class: "vue-data-ui-watermark"
}, Nl = ["onClick"], Il = { key: 0 }, Fl = { key: 1 }, Pl = {
  key: 9,
  ref: "source",
  dir: "auto"
}, Dl = { key: 0 }, Ol = { key: 1 }, El = {
  __name: "vue-ui-donut-evolution",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend"],
  setup(Ye, { expose: Ke, emit: fe }) {
    const x = Ye, { vue_ui_donut_evolution: qe } = vt(), j = p(() => !!x.dataset && x.dataset.length), h = b({
      start: 0,
      end: Math.max(...x.dataset.map((l) => l.values.length))
    });
    function ge() {
      be();
    }
    const V = b(null);
    async function be() {
      (e.value.style.chart.zoom.startIndex !== null || e.value.style.chart.zoom.endIndex !== null) && V.value ? (e.value.style.chart.zoom.startIndex !== null && (await X(), await X(), V.value && V.value.setStartValue(e.value.style.chart.zoom.startIndex)), e.value.style.chart.zoom.endIndex !== null && (await X(), await X(), V.value && V.value.setEndValue(Je(e.value.style.chart.zoom.endIndex + 1)))) : (h.value = {
        start: 0,
        end: T.value
      }, pe.value += 1);
    }
    function Je(l) {
      const u = T.value;
      return l > u ? u : l < 0 || e.value.style.chart.zoom.startIndex !== null && l < e.value.style.chart.zoom.startIndex ? e.value.style.chart.zoom.startIndex !== null ? e.value.style.chart.zoom.startIndex + 1 : 1 : l;
    }
    nt(() => {
      me();
    });
    function me() {
      dt(x.dataset) ? Z({
        componentName: "VueUiDonutEvolution",
        type: "dataset"
      }) : x.dataset.length && x.dataset.forEach((l, u) => {
        ht({
          datasetObject: l,
          requiredAttributes: ["name", "values"]
        }).forEach((t) => {
          Z({
            componentName: "VueUiDonutEvolution",
            type: "datasetSerieAttribute",
            property: t,
            index: u
          });
        });
      }), be();
    }
    const E = b(Re()), C = b([]), g = b(null), ae = b(null), $ = b(!1), A = b(null), oe = b(null), Qe = b(null), xe = b(0), pe = b(0), ke = b(0), _e = b(0), Ce = b(0), e = p({
      get: () => Le(),
      set: (l) => l
    }), { userOptionsVisible: ue, setUserOptionsVisibility: we, keepUserOptionState: ze } = Ft({ config: e.value });
    function Le() {
      const l = Be({
        userConfig: x.config,
        defaultConfig: qe
      });
      let u = {};
      return l.theme ? u = {
        ...Be({
          userConfig: yt.vue_ui_donut_evolution[l.theme] || x.config,
          defaultConfig: l
        }),
        customPalette: ft[l.theme] || ee
      } : u = l, x.config && Ue(x.config, "style.chart.zoom.startIndex") ? u.style.chart.zoom.startIndex = x.config.style.chart.zoom.startIndex : u.style.chart.zoom.startIndex = null, x.config && Ue(x.config, "style.chart.zoom.endIndex") ? u.style.chart.zoom.endIndex = x.config.style.chart.zoom.endIndex : u.style.chart.zoom.endIndex = null, u;
    }
    He(() => x.config, (l) => {
      e.value = Le(), ue.value = !e.value.showOnChartHover, me(), ke.value += 1, _e.value += 1, Ce.value += 1;
    }, { deep: !0 }), He(() => x.dataset, (l) => {
      ge();
    }, { deep: !0 });
    const { isPrinting: Se, isImaging: $e, generatePdf: Ae, generateImage: Ne } = Ct({
      elementId: E.value,
      fileName: e.value.style.chart.title.text || "vue-ui-donut-evolution"
    }), Ze = p(() => e.value.userOptions.show && !e.value.style.chart.title.text), et = p(() => gt(e.value.customPalette)), B = b({
      showTable: e.value.table.show
    }), n = p(() => ({
      top: e.value.style.chart.layout.padding.top,
      right: e.value.style.chart.layout.padding.right,
      bottom: e.value.style.chart.layout.padding.bottom,
      left: e.value.style.chart.layout.padding.left
    })), r = p(() => {
      const l = e.value.style.chart.layout.height, u = e.value.style.chart.layout.width, t = l - n.value.top - n.value.bottom, i = u - n.value.left - n.value.right;
      return {
        absoluteHeight: l,
        absoluteWidth: u,
        centerX: n.value.left + i / 2,
        centerY: n.value.top + t / 2,
        height: t,
        width: i
      };
    }), D = p(() => (x.dataset.forEach((l, u) => {
      [null, void 0].includes(l.name) && Z({
        componentName: "VueUiDonutEvolution",
        type: "datasetSerieAttribute",
        property: "name",
        index: u
      }), [null, void 0].includes(l.values) && Z({
        componentName: "VueUiDonutEvolution",
        type: "datasetSerieAttribute",
        property: "values",
        index: u
      });
    }), x.dataset.map((l, u) => ({
      ...l,
      values: bt(l.values),
      color: de(l.color) || et.value[u] || ee[u] || ee[u % ee.length],
      length: (l.values || []).length,
      uid: Re()
    })))), U = p(() => D.value.filter((l) => !C.value.includes(l.uid)).map((l) => ({
      ...l,
      values: l.values.filter((u, t) => t >= h.value.start && t <= h.value.end)
    }))), T = p(() => Math.max(...U.value.map((l) => l.length))), z = p(() => r.value.width / (h.value.end - h.value.start)), w = p(() => {
      const l = [];
      for (let s = 0; s < h.value.end - h.value.start; s += 1) {
        const f = U.value.map((I) => I.values[s] ?? null), y = f.filter((I) => [void 0, null].includes(I)).length === f.length, N = f.reduce((I, L) => I + L, 0), ve = f.map((I) => I / N), R = n.value.left + z.value * s + z.value / 2;
        l.push({
          index: s,
          percentages: ve,
          subtotal: y || N < 0 ? null : N,
          values: f,
          x: R
        });
      }
      const u = 0, t = Math.max(...l.map((s) => s.subtotal)), i = l.length === 1 ? t * 2 : t;
      return l.map((s, f) => {
        const y = z.value / 2 * 0.7, N = y > r.value.width / 16 ? r.value.width / 16 : y, ve = g.value === s.index ? r.value.width / 16 : N, R = l.length > 4 ? y * 2 : y * 2 > z.value / 2 * 0.7 ? z.value / 2 * 0.7 : y * 2, I = r.value.absoluteHeight - n.value.bottom - r.value.height * s.subtotal / We(u, i, e.value.style.chart.layout.grid.yAxis.dataLabels.steps).max;
        return {
          ...s,
          y: I,
          radius: N,
          activeRadius: ve,
          hoverRadius: R,
          donut: he({
            series: U.value.map((L, Ve) => ({
              color: L.color,
              name: L.name,
              value: L.values[f] ?? 0
            }))
          }, s.x, I, N, N, 1.99999, 2, 1, 360, 105.25, N / 2),
          donutHover: he({
            series: U.value.map((L, Ve) => ({
              color: L.color,
              name: L.name,
              value: L.values[f] ?? 0
            }))
          }, s.x, I, R, R, 1.99999, 2, 1, 360, 105.25, R / 2),
          donutFocus: he({
            series: U.value.map((L, Ve) => ({
              color: L.color,
              name: L.name,
              value: L.values[f] ?? 0
            }))
          }, r.value.centerX, r.value.centerY, r.value.height / 3.6, r.value.height / 3.6, 1.99999, 2, 1, 360, 105.25, r.value.height / 6)
        };
      });
    });
    function Y(l, u, t) {
      return ye(
        e.value.style.chart.layout.dataLabels.formatter,
        l,
        te({
          p: e.value.style.chart.layout.dataLabels.prefix,
          v: l,
          s: e.value.style.chart.layout.dataLabels.suffix,
          r: e.value.style.chart.layout.dataLabels.rounding
        }),
        { datapoint: u, index: t }
      );
    }
    const se = p(() => ({
      max: Math.max(...w.value.map((l) => l.subtotal)),
      min: 0
    })), H = p(() => {
      const l = w.value.length === 1 ? se.value.max * 2 : se.value.max;
      return We(se.value.min, l, e.value.style.chart.layout.grid.yAxis.dataLabels.steps);
    });
    function tt(l) {
      return l / H.value.max;
    }
    const lt = p(() => H.value.ticks.map((l) => ({
      y: r.value.absoluteHeight - n.value.bottom - r.value.height * tt(l),
      value: l
    })));
    function Ie(l, u) {
      return isNaN(l.value / je(u, "value")) ? 0 : (l.value / je(u, "value") * 100).toFixed(0) + "%";
    }
    function Fe() {
      $.value || (g.value = null, ae.value = null);
    }
    function at(l) {
      $.value || (g.value = l.index, ae.value = l);
    }
    const ne = b(null);
    function re(l, u) {
      l.subtotal && (ae.value = null, g.value = null, $.value = !0, A.value = l, [null, void 0].includes(u) || (ne.value = u));
    }
    function Pe() {
      A.value = null, $.value = !1, ne.value = null;
    }
    const De = p(() => D.value.map((l, u) => ({
      name: l.name,
      value: l.values.slice(h.value.start, h.value.end).reduce((t, i) => t + i, 0),
      shape: "circle",
      uid: l.uid,
      color: l.color
    })).sort((l, u) => u.value - l.value).map((l) => ({
      ...l,
      opacity: C.value.includes(l.uid) ? 0.5 : 1,
      segregate: () => ie(l.uid),
      isSegregated: C.value.includes(l.uid)
    }))), Oe = p(() => w.value.map((l) => l.subtotal).reduce((l, u) => l + u, 0)), ot = p(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    }));
    function ie(l) {
      if (C.value.includes(l))
        C.value = C.value.filter((u) => u !== l), fe("selectLegend", null);
      else {
        if (C.value.length === D.value.length - 1) return;
        C.value.push(l), fe("selectLegend", D.value.find((u) => u.uid === l));
      }
      A.value && re(w.value.find((u, t) => t === ne.value));
    }
    const M = p(() => {
      const l = [""].concat(D.value.filter((s) => !C.value.includes(s.uid)).map((s) => ({
        name: s.name,
        color: s.color
      }))).concat(["Σ"]);
      let u = [];
      for (let s = 0; s < T.value; s += 1) {
        const f = D.value.filter((y) => !C.value.includes(y.uid)).map((y) => y.values[s] ?? 0).reduce((y, N) => y + N, 0);
        u.push([e.value.style.chart.layout.grid.xAxis.dataLabels.values[s] ?? "-"].concat(D.value.filter((y) => !C.value.includes(y.uid)).map((y) => ({
          value: y.values[s] ?? 0,
          percentage: y.values[s] ? y.values[s] / f * 100 : 0
        }))).concat([`${e.value.style.chart.layout.dataLabels.prefix}${Number(f.toFixed(e.value.table.td.roundingValue))}${e.value.style.chart.layout.dataLabels.suffix}`]));
      }
      const t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      }, i = [
        e.value.table.columnNames.period
      ].concat(D.value.filter((s) => !C.value.includes(s.uid)).map((s) => s.name)).concat(e.value.table.columnNames.total);
      return { head: l, body: u, config: t, colNames: i };
    });
    function ut() {
      return D.value;
    }
    function Ee() {
      X(() => {
        const l = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [""]], u = [...M.value.head.map((f) => f.name ?? f)], t = [...M.value.body.map((f) => f.map((y) => y.value ?? y))], i = l.concat([u]).concat(t), s = pt(i);
        kt({ csvContent: s, title: e.value.style.chart.title.text || "vue-ui-donut-evolution" });
      });
    }
    const W = b(!1);
    function st(l) {
      W.value = l, xe.value += 1;
    }
    function Te() {
      B.value.showTable = !B.value.showTable;
    }
    const K = b(!1);
    function ce() {
      K.value = !K.value;
    }
    return Ke({
      getData: ut,
      generatePdf: Ae,
      generateCsv: Ee,
      generateImage: Ne,
      toggleTable: Te,
      toggleAnnotator: ce
    }), (l, u) => (a(), o("div", {
      ref_key: "donutEvolutionChart",
      ref: oe,
      class: P(`vue-ui-donut-evolution ${W.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: q(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor}`),
      id: E.value,
      onMouseenter: u[4] || (u[4] = () => c(we)(!0)),
      onMouseleave: u[5] || (u[5] = () => c(we)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (a(), O(It, {
        key: 0,
        parent: oe.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: K.value,
        onClose: ce
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : v("", !0),
      Ze.value ? (a(), o("div", {
        key: 1,
        ref_key: "noTitle",
        ref: Qe,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : v("", !0),
      e.value.style.chart.title.text ? (a(), o("div", {
        key: 2,
        style: "width:100%;background:transparent;padding-bottom:24px",
        onMouseleave: Fe
      }, [
        (a(), O(_t, {
          key: `title_${ke.value}`,
          config: {
            title: {
              cy: "donut-evolution-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-evolution-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 32)) : v("", !0),
      e.value.userOptions.show && j.value && (c(ze) || c(ue)) ? (a(), O(wt, {
        ref: "details",
        key: `user_options_${xe.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: c(Se),
        isImaging: c($e),
        uid: E.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: W.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: oe.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: K.value,
        onToggleFullscreen: st,
        onGeneratePdf: c(Ae),
        onGenerateCsv: Ee,
        onGenerateImage: c(Ne),
        onToggleTable: Te,
        onToggleAnnotator: ce,
        style: q({
          visibility: c(ze) ? c(ue) ? "visible" : "hidden" : "visible"
        })
      }, rt({ _: 2 }, [
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: F(() => [
            S(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: F(() => [
            S(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: F(() => [
            S(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: F(() => [
            S(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: F(({ toggleFullscreen: t, isFullscreen: i }) => [
            S(l.$slots, "optionFullscreen", J(Q({ toggleFullscreen: t, isFullscreen: i })), void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: F(({ toggleAnnotator: t, isAnnotator: i }) => [
            S(l.$slots, "optionAnnotator", J(Q({ toggleAnnotator: t, isAnnotator: i })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : v("", !0),
      j.value ? (a(), o("svg", {
        key: 4,
        xmlns: c(mt),
        class: P({ "vue-data-ui-fullscreen--on": W.value, "vue-data-ui-fulscreen--off": !W.value }),
        viewBox: `0 0 ${r.value.absoluteWidth} ${r.value.absoluteHeight}`,
        style: q(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        it(Nt),
        l.$slots["chart-background"] ? (a(), o("foreignObject", {
          key: 0,
          x: n.value.left,
          y: n.value.top,
          width: r.value.width,
          height: r.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          S(l.$slots, "chart-background", {}, void 0, !0)
        ], 8, Et)) : v("", !0),
        d("defs", null, [
          d("linearGradient", {
            id: `hover_${E.value}`,
            x1: "0%",
            y1: "0%",
            x2: "0%",
            y2: "100%"
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": c(G)(e.value.style.chart.backgroundColor, e.value.style.chart.layout.highlighter.opacity)
            }, null, 8, Vt),
            d("stop", {
              offset: "100%",
              "stop-color": c(G)(e.value.style.chart.layout.highlighter.color, e.value.style.chart.layout.highlighter.opacity)
            }, null, 8, Ht)
          ], 8, Tt),
          d("radialGradient", {
            id: `focus_${E.value}`
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": c(G)(c(de)(e.value.style.chart.backgroundColor), 0)
            }, null, 8, Rt),
            d("stop", {
              offset: "77%",
              "stop-color": c(G)("#FFFFFF", 30)
            }, null, 8, Ut),
            d("stop", {
              offset: "100%",
              "stop-color": c(G)(c(de)(e.value.style.chart.backgroundColor), 0)
            }, null, 8, Wt)
          ], 8, Mt)
        ]),
        e.value.style.chart.layout.grid.show ? (a(), o("g", Xt, [
          d("line", {
            x1: n.value.left,
            x2: n.value.left,
            y1: n.value.top,
            y2: n.value.top + r.value.height,
            stroke: e.value.style.chart.layout.grid.stroke,
            "stroke-width": e.value.style.chart.layout.grid.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Gt),
          d("line", {
            x1: n.value.left,
            x2: r.value.absoluteWidth - n.value.right,
            y1: r.value.absoluteHeight - n.value.bottom,
            y2: r.value.absoluteHeight - n.value.bottom,
            stroke: e.value.style.chart.layout.grid.stroke,
            "stroke-width": e.value.style.chart.layout.grid.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, jt),
          e.value.style.chart.layout.grid.showVerticalLines ? (a(), o("g", Bt, [
            (a(!0), o(k, null, _(h.value.end - h.value.start, (t, i) => (a(), o("line", {
              x1: n.value.left + (i + 1) * z.value,
              x2: n.value.left + (i + 1) * z.value,
              y1: n.value.top,
              y2: r.value.absoluteHeight - n.value.bottom,
              stroke: e.value.style.chart.layout.grid.stroke,
              "stroke-width": e.value.style.chart.layout.grid.strokeWidth,
              "stroke-linecap": "round"
            }, null, 8, Yt))), 256))
          ])) : v("", !0)
        ])) : v("", !0),
        e.value.style.chart.layout.grid.yAxis.dataLabels.show ? (a(), o("g", {
          key: 2,
          class: P({ "donut-opacity": !0, "donut-behind": g.value !== null || $.value })
        }, [
          (a(!0), o(k, null, _(lt.value, (t, i) => (a(), o("g", null, [
            t.value >= H.value.min && t.value <= H.value.max ? (a(), o("line", {
              key: 0,
              x1: n.value.left,
              x2: n.value.left - 5,
              y1: t.y,
              y2: t.y,
              stroke: e.value.style.chart.layout.grid.stroke,
              "stroke-width": e.value.style.chart.layout.grid.strokeWidth
            }, null, 8, Kt)) : v("", !0),
            t.value >= H.value.min && t.value <= H.value.max ? (a(), o("text", {
              key: 1,
              x: n.value.left - 8 + e.value.style.chart.layout.grid.yAxis.dataLabels.offsetX,
              y: t.y + e.value.style.chart.layout.grid.yAxis.dataLabels.fontSize / 3,
              "font-size": e.value.style.chart.layout.grid.yAxis.dataLabels.fontSize,
              "text-anchor": "end",
              fill: e.value.style.chart.layout.grid.yAxis.dataLabels.color,
              "font-weight": e.value.style.chart.layout.grid.yAxis.dataLabels.bold ? "bold" : "normal"
            }, m(c(xt)(t.value) ? c(ye)(
              e.value.style.chart.layout.dataLabels.formatter,
              t.value,
              c(te)({
                p: e.value.style.chart.layout.dataLabels.prefix,
                v: t.value,
                s: e.value.style.chart.layout.dataLabels.suffix,
                r: e.value.style.chart.layout.grid.yAxis.dataLabels.roundingValue
              }),
              { datapoint: t, seriesIndex: i }
            ) : ""), 9, qt)) : v("", !0)
          ]))), 256))
        ], 2)) : v("", !0),
        e.value.style.chart.layout.grid.xAxis.dataLabels.show ? (a(), o("g", {
          key: 3,
          class: P({ "donut-opacity": !0, "donut-behind": $.value })
        }, [
          (a(!0), o(k, null, _(h.value.end - h.value.start, (t, i) => (a(), o("g", null, [
            e.value.style.chart.layout.grid.xAxis.dataLabels.showOnlyFirstAndLast && (i === 0 || i === T.value - 1) || !e.value.style.chart.layout.grid.xAxis.dataLabels.showOnlyFirstAndLast ? (a(), o("text", {
              key: 0,
              "text-anchor": e.value.style.chart.layout.grid.xAxis.dataLabels.rotation > 0 ? "start" : e.value.style.chart.layout.grid.xAxis.dataLabels.rotation < 0 ? "end" : "middle",
              "font-size": e.value.style.chart.layout.grid.xAxis.dataLabels.fontSize,
              fill: e.value.style.chart.layout.grid.xAxis.dataLabels.color,
              transform: `translate(${n.value.left + z.value * i + z.value / 2}, ${e.value.style.chart.layout.grid.xAxis.dataLabels.offsetY + r.value.absoluteHeight - n.value.bottom + e.value.style.chart.layout.grid.xAxis.dataLabels.fontSize * 2}), rotate(${e.value.style.chart.layout.grid.xAxis.dataLabels.rotation})`
            }, m(e.value.style.chart.layout.grid.xAxis.dataLabels.values[Number(i) + Number(h.value.start)] ?? ""), 9, Jt)) : v("", !0)
          ]))), 256))
        ], 2)) : v("", !0),
        (a(!0), o(k, null, _(w.value, (t, i) => (a(), o("g", null, [
          e.value.style.chart.layout.line.show && i < w.value.length - 1 && ![t.subtotal, w.value[i + 1].subtotal].includes(null) ? (a(), o("line", {
            key: 0,
            class: P({ "donut-opacity": !0, "donut-behind": g.value !== null || $.value }),
            x1: t.x,
            y1: t.y,
            x2: w.value[i + 1].x,
            y2: w.value[i + 1].y,
            stroke: e.value.style.chart.layout.line.stroke,
            "stroke-width": e.value.style.chart.layout.line.strokeWidth,
            "stroke-linecap": "round",
            "stroke-linejoin": "round"
          }, null, 10, Qt)) : v("", !0),
          t.subtotal !== null ? (a(), o("g", Zt, [
            t.subtotal ? (a(), o("circle", {
              key: 0,
              cx: t.x,
              cy: t.y,
              r: t.activeRadius,
              fill: e.value.style.chart.backgroundColor
            }, null, 8, el)) : v("", !0)
          ])) : v("", !0)
        ]))), 256)),
        (a(!0), o(k, null, _(w.value, (t, i) => (a(), o("g", {
          class: P({ "donut-opacity": !0, "donut-behind": i !== g.value && g.value !== null || $.value })
        }, [
          t.subtotal ? (a(), o("g", tl, [
            g.value !== null && g.value === i ? (a(), o("g", ll, [
              (a(!0), o(k, null, _(t.donutHover, (s) => (a(), o("g", null, [
                d("path", {
                  d: c(Xe)(s, { x: s.center.endX, y: s.center.endY }, 12, 12, { x: t.x, y: t.y }, !0, 20),
                  stroke: s.color,
                  "stroke-width": "1",
                  "stroke-linecap": "round",
                  "stroke-linejoin": "round",
                  fill: "none"
                }, null, 8, al)
              ]))), 256)),
              (a(!0), o(k, null, _(t.donutHover, (s, f) => (a(), o("g", null, [
                d("text", {
                  "data-cy-hover-label": "",
                  "text-anchor": c(le)(s, !0, 0).anchor,
                  x: c(le)(s, !0, 3).x,
                  y: c(Ge)(s),
                  fill: e.value.style.chart.layout.grid.yAxis.dataLabels.color,
                  "font-size": 8,
                  "font-weight": "bold"
                }, m(s.name) + ": " + m(Ie(s, t.donut)) + " (" + m(s.value === null ? "-" : Y(s.value, s, f)) + ") ", 9, ol)
              ]))), 256)),
              d("g", null, [
                d("circle", {
                  cx: t.x,
                  cy: t.y,
                  r: t.hoverRadius,
                  fill: e.value.style.chart.backgroundColor
                }, null, 8, ul)
              ])
            ])) : v("", !0)
          ])) : v("", !0)
        ], 2))), 256)),
        (a(!0), o(k, null, _(w.value, (t, i) => (a(), o("g", {
          class: P({ "donut-opacity": !0, "donut-behind": i !== g.value && g.value !== null || $.value })
        }, [
          t.subtotal !== null ? (a(), o("g", sl, [
            t.subtotal === 0 ? (a(), o("circle", {
              key: 0,
              cx: t.x,
              cy: t.y,
              r: 3,
              fill: e.value.style.chart.color
            }, null, 8, nl)) : g.value !== null && g.value === i ? (a(), o("g", rl, [
              (a(!0), o(k, null, _(t.donutHover, (s, f) => (a(), o("path", {
                d: s.arcSlice,
                fill: `${s.color}`,
                "stroke-width": 1,
                stroke: e.value.style.chart.backgroundColor
              }, null, 8, il))), 256))
            ])) : (a(), o("g", cl, [
              (a(!0), o(k, null, _(t.donut, (s, f) => (a(), o("path", {
                d: s.arcSlice,
                fill: `${s.color}`,
                "stroke-width": 0.5,
                stroke: e.value.style.chart.backgroundColor
              }, null, 8, vl))), 256))
            ]))
          ])) : v("", !0)
        ], 2))), 256)),
        (a(!0), o(k, null, _(w.value, (t, i) => (a(), o("g", {
          class: P({ "donut-opacity": !0, "donut-behind": i !== g.value && g.value !== null || $.value })
        }, [
          t.subtotal !== null && e.value.style.chart.layout.dataLabels.show ? (a(), o("text", {
            key: 0,
            "text-anchor": "middle",
            x: t.x,
            y: g.value === t.index && t.subtotal ? t.y + e.value.style.chart.layout.dataLabels.fontSize / 3 : t.y - t.radius - e.value.style.chart.layout.dataLabels.fontSize + e.value.style.chart.layout.dataLabels.offsetY,
            "font-size": e.value.style.chart.layout.dataLabels.fontSize,
            "font-weight": "bold",
            fill: e.value.style.chart.layout.dataLabels.color
          }, m(Y(t.subtotal, t, i)), 9, dl)) : v("", !0)
        ], 2))), 256)),
        (a(!0), o(k, null, _(w.value, (t, i) => (a(), o("rect", {
          x: n.value.left + i * z.value,
          y: r.value.absoluteHeight - n.value.bottom - 10,
          width: z.value,
          height: 10,
          fill: g.value === t.index ? `url(#hover_${E.value})` : "transparent",
          onClick: (s) => re(t, i),
          class: P({ "donut-hover": g.value === t.index && t.subtotal })
        }, null, 10, hl))), 256)),
        (a(!0), o(k, null, _(w.value, (t, i) => (a(), o("rect", {
          "data-cy-trap": "",
          x: n.value.left + i * z.value,
          y: n.value.top,
          width: z.value,
          height: r.value.height,
          fill: "transparent",
          onMouseenter: (s) => at(t),
          onMouseleave: Fe,
          onClick: (s) => re(t, i),
          class: P({ "donut-hover": g.value === t.index && t.subtotal })
        }, null, 42, yl))), 256)),
        $.value ? (a(), o("g", fl, [
          d("rect", {
            rx: 4,
            x: n.value.left,
            y: n.value.top,
            width: r.value.width,
            height: r.value.height,
            fill: e.value.style.chart.backgroundColor,
            style: { filter: "drop-shadow(0 12px 12px rgba(0,0,0,0.3))" }
          }, null, 8, gl),
          d("line", {
            "data-html2canvas-ignore": "",
            x1: r.value.absoluteWidth - n.value.right - 15,
            y1: n.value.top + 5,
            x2: r.value.absoluteWidth - n.value.right - 4,
            y2: n.value.top + 15.5,
            "stroke-linecap": "round",
            stroke: e.value.style.chart.color,
            "stroke-width": "1.5"
          }, null, 8, bl),
          d("line", {
            "data-html2canvas-ignore": "",
            x1: r.value.absoluteWidth - n.value.right - 15,
            y2: n.value.top + 5,
            x2: r.value.absoluteWidth - n.value.right - 4,
            y1: n.value.top + 15.5,
            "stroke-linecap": "round",
            stroke: e.value.style.chart.color,
            "stroke-width": "1.5"
          }, null, 8, ml),
          d("circle", {
            "data-cy-close": "",
            onClick: Pe,
            onKeypress: ct(Pe, ["enter"]),
            cx: r.value.absoluteWidth - n.value.right - r.value.width / 40,
            cy: n.value.top + r.value.height / 30,
            r: r.value.height / 12,
            fill: "transparent",
            style: { cursor: "pointer" },
            tabindex: "0"
          }, null, 40, xl),
          (a(!0), o(k, null, _(A.value.donutFocus, (t) => (a(), o("g", null, [
            d("path", {
              "data-cy-zoom-donut": "",
              d: c(Xe)(t, { x: r.value.centerX, y: r.value.centerY }, 12, 12, !1, !1, 15),
              stroke: t.color,
              "stroke-width": "1",
              "stroke-linecap": "round",
              "stroke-linejoin": "round",
              fill: "none",
              class: "vue-ui-donut-evolution-focus"
            }, null, 8, pl)
          ]))), 256)),
          d("circle", {
            cx: n.value.left + r.value.width / 2,
            cy: n.value.top + r.value.height / 2,
            r: r.value.height / 7,
            fill: e.value.style.chart.backgroundColor
          }, null, 8, kl),
          (a(!0), o(k, null, _(A.value.donutFocus, (t, i) => (a(), o("path", {
            d: t.arcSlice,
            fill: `${t.color}`,
            "stroke-width": 1,
            stroke: e.value.style.chart.backgroundColor,
            class: "vue-ui-donut-evolution-focus"
          }, null, 8, _l))), 256)),
          (a(!0), o(k, null, _(A.value.donutFocus, (t, i) => (a(), o("g", Cl, [
            d("text", {
              "text-anchor": c(le)(t, !0, 20).anchor,
              x: c(le)(t, !0, 10).x,
              y: c(Ge)(t),
              fill: e.value.style.chart.layout.grid.yAxis.dataLabels.color,
              "font-size": 10,
              "font-weight": "bold"
            }, m(t.name) + ": " + m(Ie(t, A.value.donutFocus)) + " (" + m(t.value === null ? "-" : Y(t.value, t, i)) + ") ", 9, wl)
          ]))), 256)),
          d("circle", {
            cx: n.value.left + r.value.width / 2,
            cy: n.value.top + r.value.height / 2,
            r: r.value.height / 3.8,
            fill: `url(#focus_${E.value})`
          }, null, 8, zl),
          d("circle", {
            cx: n.value.left + r.value.width / 2,
            cy: n.value.top + r.value.height / 2,
            r: r.value.height / 7.7,
            fill: e.value.style.chart.backgroundColor
          }, null, 8, Ll),
          d("text", {
            "text-anchor": "middle",
            x: n.value.left + r.value.width / 2,
            y: n.value.top + r.value.height / 2 + 14 / 3,
            "font-size": 14,
            "font-weight": "bold",
            fill: e.value.style.chart.layout.dataLabels.color,
            class: "vue-ui-donut-evolution-focus"
          }, m(Y(A.value.subtotal, A.value, null)), 9, Sl),
          e.value.style.chart.layout.grid.xAxis.dataLabels.values[A.value.index] ? (a(), o("text", {
            key: 0,
            x: n.value.left + 6,
            y: n.value.top + e.value.style.chart.layout.grid.xAxis.dataLabels.fontSize * 2,
            "font-size": e.value.style.chart.layout.grid.xAxis.dataLabels.fontSize * 1.6,
            fill: e.value.style.chart.layout.dataLabels.color
          }, m(e.value.style.chart.layout.grid.xAxis.dataLabels.values[Number(A.value.index) + Number(h.value.start)]), 9, $l)) : v("", !0)
        ])) : v("", !0),
        S(l.$slots, "svg", { svg: r.value }, void 0, !0)
      ], 14, Ot)) : v("", !0),
      l.$slots.watermark ? (a(), o("div", Al, [
        S(l.$slots, "watermark", J(Q({ isPrinting: c(Se) || c($e) })), void 0, !0)
      ])) : v("", !0),
      j.value ? v("", !0) : (a(), O(St, {
        key: 6,
        config: {
          type: "donutEvolution",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donutEvolution: {
              axis: {
                color: "#CCCCCC"
              },
              donuts: {
                color: "#CCCCCC"
              }
            }
          }
        }
      }, null, 8, ["config"])),
      T.value > 1 && e.value.style.chart.zoom.show ? (a(), O($t, {
        ref_key: "slicerComponent",
        ref: V,
        key: `slicer_${pe.value}`,
        background: e.value.style.chart.zoom.color,
        borderColor: e.value.style.chart.backgroundColor,
        fontSize: e.value.style.chart.zoom.fontSize,
        useResetSlot: e.value.style.chart.zoom.useResetSlot,
        labelLeft: e.value.style.chart.layout.grid.xAxis.dataLabels.values[Number(h.value.start)] || "",
        labelRight: e.value.style.chart.layout.grid.xAxis.dataLabels.values[Number(h.value.end) - 1] || "",
        textColor: e.value.style.chart.color,
        inputColor: e.value.style.chart.zoom.color,
        selectColor: e.value.style.chart.zoom.highlightColor,
        max: T.value,
        min: 0,
        valueStart: h.value.start,
        valueEnd: h.value.end,
        start: h.value.start,
        "onUpdate:start": u[0] || (u[0] = (t) => h.value.start = t),
        end: h.value.end,
        "onUpdate:end": u[1] || (u[1] = (t) => h.value.end = t),
        refreshStartPoint: e.value.style.chart.zoom.startIndex !== null ? e.value.style.chart.zoom.startIndex : 0,
        refreshEndPoint: e.value.style.chart.zoom.endIndex !== null ? e.value.style.chart.zoom.endIndex + 1 : T.value,
        enableRangeHandles: e.value.style.chart.zoom.enableRangeHandles,
        enableSelectionDrag: e.value.style.chart.zoom.enableSelectionDrag,
        onReset: ge
      }, {
        "reset-action": F(({ reset: t }) => [
          S(l.$slots, "reset-action", J(Q({ reset: t })), void 0, !0)
        ]),
        _: 3
      }, 8, ["background", "borderColor", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "max", "valueStart", "valueEnd", "start", "end", "refreshStartPoint", "refreshEndPoint", "enableRangeHandles", "enableSelectionDrag"])) : v("", !0),
      e.value.style.chart.legend.show ? (a(), O(Lt, {
        key: `legend_${Ce.value}`,
        legendSet: De.value,
        config: ot.value,
        onClickMarker: u[2] || (u[2] = ({ legend: t }) => ie(t.uid))
      }, {
        item: F(({ legend: t, index: i }) => [
          d("div", {
            "data-cy-legend-item": "",
            onClick: (s) => ie(t.uid),
            style: q(`opacity:${C.value.includes(t.uid) ? 0.5 : 1}`)
          }, [
            Me(m(t.name) + ": " + m(c(ye)(
              e.value.style.chart.layout.dataLabels.formatter,
              t.value,
              c(te)({
                p: e.value.style.chart.layout.dataLabels.prefix,
                v: t.value,
                s: e.value.style.chart.layout.dataLabels.suffix,
                r: e.value.style.chart.legend.roundingValue
              }),
              { datapoint: t, seriesIndex: i }
            )) + " ", 1),
            C.value.includes(t.uid) ? (a(), o("span", Fl, " ( - % ) ")) : (a(), o("span", Il, " (" + m(isNaN(t.value / Oe.value) ? "-" : c(te)({
              v: t.value / Oe.value * 100,
              s: "%",
              r: e.value.style.chart.legend.roundingPercentage
            })) + ") ", 1))
          ], 12, Nl)
        ]),
        _: 1
      }, 8, ["legendSet", "config"])) : v("", !0),
      S(l.$slots, "legend", { legend: De.value }, void 0, !0),
      l.$slots.source ? (a(), o("div", Pl, [
        S(l.$slots, "source", {}, void 0, !0)
      ], 512)) : v("", !0),
      j.value ? (a(), O(At, {
        key: 10,
        hideDetails: "",
        config: {
          open: B.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: F(() => [
          (a(), O(zt, {
            key: `table_${_e.value}`,
            colNames: M.value.colNames,
            head: M.value.head,
            body: M.value.body,
            config: M.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: u[3] || (u[3] = (t) => B.value.showTable = !1)
          }, {
            th: F(({ th: t }) => [
              Me(m(t.name ?? t), 1)
            ]),
            td: F(({ td: t }) => [
              t.value === null ? (a(), o("span", Dl, "-")) : (a(), o("b", Ol, m(isNaN(t.value) ? "" : e.value.style.chart.layout.dataLabels.prefix) + m(!isNaN(t.value) && t.value !== null ? Number(t.value.toFixed(e.value.table.td.roundingValue)).toLocaleString() : t) + m(isNaN(t.value) ? "" : e.value.style.chart.layout.dataLabels.suffix), 1)),
              d("span", null, m(t.percentage && !isNaN(t.percentage) ? `(${Number(t.percentage.toFixed(e.value.table.td.roundingPercentage)).toLocaleString()}%)` : ""), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : v("", !0)
    ], 46, Dt));
  }
}, Jl = /* @__PURE__ */ Pt(El, [["__scopeId", "data-v-bfca0728"]]);
export {
  Jl as default
};
